function val = J(f1,f2,u11,u12,u21, u22,kt)

% Evaluating the functional.
[a,  b, m, h, x, y, Nt, t, dt, nu, eta, rho] = parameters(kt);


for k = 1:Nt-1
    t1 = t(k);
    tr1 = traj1(t1,1);
    tr2 = traj2(t1,1);
    
    for i = 1:m
        for j = 1:m
            val1(i,j) = rho^2*f1(i,j,k)*f2(i,j,k);

        end
    end
    integ1(k) = sum(sum(val1)*h^2)...
        + (nu/2)*u11(k)^2+(eta/2)*((u11(k+1)-u11(k))/dt)^2 ...
        + (nu/2)*u12(k)^2+(eta/2)*((u12(k+1)-u12(k))/dt)^2 ...
        + (nu/2)*u21(k)^2+(eta/2)*((u21(k+1)-u21(k))/dt)^2 ...
        + (nu/2)*u22(k)^2+(eta/2)*((u22(k+1)-u22(k))/dt)^2;
end

t1 = t(Nt);
tr1 = traj1(t1,1);
tr2 = traj2(t1,1);

for i = 1:m+1
    for j = 1:m+1
        val2(i,j) = V1(x(i),y(j),tr1)*f1(i,j,Nt)+V2(x(i),y(j),tr2)*f2(i,j,Nt);
    end
end
integ2 = sum(sum(val2)*h^2);

val = sum(integ1)*dt + integ2;